Changesets link to issues even without the keyword prefix

2011-08-24 17:23 - Andrew Betts

Status: New Start date: 2011-08-24

Priority: Normal Due date:  

Assignee:  % Done: 0%

Category: SCM Estimated time: 0.00 hour

Target version:    

Resolution:  Affected version: 1.2.1

Description

In settings, it is possible to configure a keyword that must be prefixed to #number in order to link the changeset to a redmine issue. 

However, redmine appears to ignore this and links the changeset to any issues that match numbers prefixed with hashes in the text

of the comment.

For example, if I wrote in a commit message:

"Removed the text '#4' from this page (redmine #5)"

This will get associated (correctly) with issue 5, and incorrectly with issue 4, which it has nothing to do with.  I have found a fix for the

association, which is to remove the question mark following the second capturing subgroup on line 117 of app/models/changeset.rb. 

This makes the keyword mandatory in the scan_comment_for_issue_ids method.  However, I can't figure out how to prevent the #4

from becoming a link to issue 4 in the revision history page.  This seems to be a very low level thing, and I'm afraid I am not a rails

developer so the trail went cold on that one.

History

#1 - 2011-08-24 17:24 - Andrew Betts

I should have stated that in my test case, I am assuming that the repository settings are configured to require a keyword prefix of 'redmine'.

#2 - 2011-08-24 18:24 - Etienne Massip

- Category set to SCM

Did you remove the asterisk?

#3 - 2011-08-24 18:54 - Andrew Betts

- File Screen_Shot_2011-08-24_at_17.53.22.png added

Yes, my settings look like this.

#4 - 2011-08-25 09:30 - Andrew Betts

Slightly better example: We have multiple tracking systems, so sometimes there are #number references in our commit messages that do not relate

to redmine.  In this commit message:

redmine 3907, redmine #2839, #2138, helpdesk 1975, helpdesk #1974, #1503

I would expect redmine to link #2839 and possibly #2138, but not 3907, 1975, 1974 or 1503.  In practice it links anything that matches the #number

pattern, regardless of its prefix, which means it's linking the helpdesk request IDs to irrelevant redmine issues.
